function kn = linearTM( Nx, Ny);

global ks ind kn Ny Nx E dx dy ind Hr

handle=findobj('Tag','osax');
Nx=str2num(get(handle,'String'));

handle=findobj('Tag','osay');
Ny=str2num(get(handle,'String'));

a  = 22.86e-3;                % ka vlnovodu
b  = 10.16e-3;                % vka vlnovodu

dx = ones(1,Nx) * (a/Nx);     % vektory rozmr k.p.
dy = ones(1,Ny) * (b/Ny);

Q1 = [  0  0  0;  0  1 -1;  0 -1  1] / 2;
Q3 = [  1 -1  0; -1  1  0;  0  0  0] / 2;
Te = [  2  1  1;  1  2  1;  1  1  2] /12;

N  = 2 * Nx * Ny;             % celkov poet k.p.
St = sparse( 3*N, 3*N);
Tt = sparse( 3*N, 3*N);

n = 0;                        % matice pro izolovan k.p.
for ny=1:Ny
  for nx=1:Nx
    n  = n + 1;
    lw = 3*n-2;
    hg = 3*n;
    St(lw:hg,lw:hg) = Q1 * dx(nx)/dy(ny) + Q3 * dy(ny)/dx(nx);
    Tt(lw:hg,lw:hg) = Te * dx(nx)*dy(ny)/2;
    St(lw+3*Nx:hg+3*Nx,lw+3*Nx:hg+3*Nx) = St(lw:hg,lw:hg);
    Tt(lw+3*Nx:hg+3*Nx,lw+3*Nx:hg+3*Nx) = Tt(lw:hg,lw:hg);
  end
  n = n + Nx;
end

C = get_c1( Nx, Ny, N);

S = C'*St*C; 
T = C'*Tt*C;

clear C St Tt

iNx = Nx + 1; iNy = Ny + 1;

S = S(Nx+2:iNx*Ny,Nx+2:iNx*Ny); % vynechn doln a horn stny
T = T(Nx+2:iNx*Ny,Nx+2:iNx*Ny);
ind = 2;
for n=2:Ny                      % vynechn dk
  lw  = (n-2)*(Nx-1);
  hg  = (n-1)*(Nx-1);
  Sr(lw+1:hg,1:(Ny-1)*iNx) = S(lw+ind:hg+ind-1,:);
  Tr(lw+1:hg,1:(Ny-1)*iNx) = T(lw+ind:hg+ind-1,:);
  ind = ind + 2;
end
ind = 2;
for n=2:Ny                      % vynechn sloupc
  lw  = (n-2)*(Nx-1);
  hg  = (n-1)*(Nx-1);
  St(1:(Nx-1)*(Ny-1),lw+1:hg) = Sr(:,lw+ind:hg+ind-1);
  Tt(1:(Nx-1)*(Ny-1),lw+1:hg) = Tr(:,lw+ind:hg+ind-1);
  ind = ind + 2;
end

clear S T Sr Tr
[E,K] = eig( full(St), full(Tt));
kn  = sqrt( diag( K));

Em = zeros( iNy, iNx);
[ks,ind] = sort( kn);

vidytm;
%nr = input('vid slo:');

